--[[

	RealmTypeNotification - version 1.0 (8/1/14)
	Faucette - Dalaran (US)

	Description
	===========
	Adds colored realm-type (PvP or PvE) information to the cross-realm invite popup.
	===========

	Change Log
	==========
	1.0		- Initial Release
	==========

]]--

local realmList = {
	["US"] = {
			"Aegwynn", "Agamaggan", "Akama", "AltarofStorms", "AlteracMountains",
			"Andorhal", "Anetheron", "Anub'arak", "Archimonde", "Arthas",
			"Auchindoun", "Azgalor", "Azralon", "Azshara", "Balnazzar",
			"Barthilas", "BlackDragonflight", "Blackrock", "BlackwingLair", "BleedingHollow",
			"BloodFurnace", "Bloodscalp", "Bonechewer", "Boulderfist", "BurningBlade",
			"BurningLegion", "Cho'gall", "Chromaggus", "Coilfang", "Crushridge",
			"Daggerspine", "Dalvengyr", "DarkIron", "Darkspear", "Deathwing",
			"DemonSoul", "Destromath", "Dethecus", "Detheroc", "Dragonmaw",
			"Drak'Tharon", "Drakkari", "Dreadmaul", "Dunemaul", "EmeraldDream",
			"Eredar", "Executus", "Firetree", "Frostmane", "Frostmourne",
			"Frostwolf", "Garithos", "Gorefiend", "Gorgonnash", "Gul'dan",
			"Gundrak", "Gurubashi", "Hakkar", "Haomarush", "Illidan",
			"Jaedenar", "Jubei'Thos", "Kalecgos", "Kel'Thuzad", "Kil'jaeden",
			"Korgath", "LaughingSkull", "Lethon", "Lightning'sBlade", "Lightninghoof",
			"Maelstrom", "Magtheridon", "Maiev", "Mal'Ganis", "Malorne",
			"Mannoroth", "Mug'thol", "Nathrezim", "Nazjatar", "Nemesis",
			"Ner'zhul", "Onyxia", "Ragnaros", "Ravenholdt", "Rivendare",
			"Sargeras", "Scilla", "Shadowmoon", "ShatteredHalls", "ShatteredHand",
			"Skullcrusher", "Smolderthorn", "Spinebreaker", "Spirestone", "Stonemaul",
			"Stormreaver", "Stormscale", "Thaurissan", "TheForgottenCoast", "TheUnderbog",
			"TheVentureCo", "Thunderlord", "Tichondrius", "TolBarad", "Tortheldrin",
			"Twisting Nether", "Ursin", "Vashj", "Warsong", "Wildhammer",
			"Ysondre", "Zuluhed"
		 },
	["EU"] = { -- Untested; not sure if all of these work (especially Aggra with the parantheses)
			"Aegwynn", "Agamaggan", "Aggra(Portugus)", "Ahn'Qiraj", "Al'Akir",
			"Anetheron", "Anub'arak", "Arak-arahm", "Arathi", "Archimonde",
			"Arthas", "Ashenvale", "Auchindoun", "Azshara", "Balnazzar",
			"Blackmoore", "Blackrock", "Blackscar", "Bladefist", "Bloodfeather",
			"Bloodscalp", "Blutkessel", "BootyBay", "Boulderfist", "BurningBlade",
			"BurningLegion", "BurningSteppes", "C'Thun", "Cho'gall", "Chromaggus",
			"ConseildesOmbres", "Crushridge", "CultedelaRivenoire", "Daggerspine", "Dalvengyr",
			"Darksorrow", "DasKonsortium", "DasSyndikat", "Deathguard", "Deathweaver",
			"Deathwing", "Deepholm", "DefiasBrotherhood", "Dentarg", "DerabyssischeRat",
			"Destromath", "Dethecus", "DieArguswacht", "DieTodeskrallen", "Dragonmaw",
			"Drak'thul", "DunModr", "Dunemaul", "Echsenkessel", "Eldre'Thalas",
			"Emeriss", "Eredar", "Executus", "FestungderStrme", "Frostmane",
			"Frostmourne", "Frostwhisper", "Frostwolf", "Garona", "Genjuros",
			"Gordunni", "Gorgonnash", "Greymane", "Grim Batol", "Grom",
			"Gul'dan", "Hakkar", "Haomarush", "HowlingFjord", "Illidan",
			"Jaedenar", "Kael'thas", "Karazhan", "Kazzak", "Kel'Thuzad",
			"Kil'jaeden", "Kor'gall", "Krag'jin", "KultderVerdammten", "LaCroisadecarlate",
			"LaughingSkull", "LichKing", "Lightning'sBlade", "Mal'Ganis", "Mannoroth",
			"Mug'thol", "Nathrezim", "Naxxramas", "Nazjatar", "Nefarian",
			"Nemesis", "Neptulon", "Ner'zhul", "Nera'thor", "Onyxia",
			"Outland", "Ragnaros", "Rajaxx", "Rashgarroth", "Ravencrest",
			"Ravenholdt", "Razuvious", "Sanguino", "Sargeras", "ScarshieldLegion",
			"ShatteredHalls", "ShatteredHand", "Shen'dralar", "Sinstralis", "Skullcrusher",
			"Soulflayer", "Spinebreaker", "Sporeggar", "Stormreaver", "Stormscale",
			"Sunstrider", "Sylvanas", "Taerar", "Talnivarr", "Tarren Mill",
			"Templenoir", "Terrordar", "TheMaelstrom", "TheVentureCo", "Theradras",
			"Thermaplugg", "Throk'Feroth", "Trollbane", "Twilight'sHammer", "TwistingNether",
			"Uldum", "Vashj", "Vek'lor", "Wrathbringer", "Xavius",
			"Ysondre", "Zenedar", "Zul'jin", "Zuluhed"
		 },
	["Other"] = {
			-- Unknown
		 }
}

local locale = GetLocale();

local localeList = {
	["deDE"] = "EU",
	["enGB"] = "EU", -- Wowpedia indicates this possibly is not returned and "enGB" clients see the US value instead (I have no way to test)
	["enUS"] = "US",
	["esES"] = "EU",
	["esMX"] = "US",
	["frFR"] = "EU",
	["itIT"] = "EU",
	["koKR"] = "Other",
	["ptBR"] = "US",
	["ruRU"] = "EU",
	["zhCN"] = "Other",
	["zhTW"] = "Other"
}

local popup = "PARTY_INVITE_XREALM"
local realmGroup = localeList[locale] or "US"

local HookStaticPopup = function(...)
	local which, name = ...

	if which ~= popup then
		return
	end

	local player, realm = string.match(name, "(.+)\-(.+)")
	--print("Invite from realm:", realm);

	local isPvP = false

	for _,v in pairs(realmList[realmGroup]) do
		if v == realm then
			isPvP = true
			break
		end
	end

	--print("PvP:", isPvP and "Yes" or "No")
	local type = isPvP and "PvP" or "PvE"
	local color = isPvP and "FF0000" or "00FF00"	

	local dialog, frame = StaticPopup_Visible(popup) -- Should be found as this is a post-hook; unless no popup was available to use
	local info = StaticPopupDialogs[popup]
	if dialog and info then
		local text = _G[dialog.."Text"]
		local formattedName = string.format("%s-|cFF%s%s (%s)|r", player, color, realm, type)
		text:SetFormattedText(info.text, formattedName)
		StaticPopup_Resize(frame, popup);
	end
end

hooksecurefunc("StaticPopup_Show", HookStaticPopup);